module Gersdorf.ContextMatching.Base.EquationSet (
    EquationSet(..),
    PosEquationSet,
    module Gersdorf.ContextMatching.Base.TermEquation
) where

import Gersdorf.ContextMatching.Base.TermEquation
import Gersdorf.ContextMatching.Base.PositionTerm

-- | Ein EquationSet ist eine Menge von Gleichungen. Die Menge von Gleichungen
-- kann auch gleich BOT sein. 
class (Term t, TermEquation e t, Show (es e t), Eq (es e t)) => EquationSet es e t where
   -- | Kreiert ein neues leeres EquationSet
   emptySet :: es e t
   -- | Kreiert ein EquationSet, das gleich BOT ist
   cBotSet  :: es e t
   -- | Kreiert ein EquationSet aus einer Menge von Gleichungen
   cSet :: [e t] -> es e t
   -- | Fgt zu einem EquationSet eine weitere Gleichung hinzu
   addToSet :: es e t -> e t -> es e t
   
   -- | Konvertiert ein EquationSet in eine Liste von Gleichungen
   toEquationList :: es e t -> [e t]

   -- | Prft, ob das EquationSet leer ist
   isEmpty :: es e t -> Bool

   -- | Prft, ob das EquationSet gleich BOT ist
   isEqBot :: es e t -> Bool

-- | Ein PosEquationSet ist ein EquationSet, welches als Gleichungsterme
-- PositionTerms enthlt
class (EquationSet es e t, PositionTerm t tp) => PosEquationSet es e t tp
