module Gersdorf.ContextMatching.Base.ListEquationSet (
    ListEquationSet,
    module Gersdorf.ContextMatching.Base.EquationSet
) where

import Debug.Trace

import Gersdorf.ContextMatching.Base.EquationSet
import Gersdorf.Data.List
import Gersdorf.Data.BacktrackingChoice

data (TermEquation e t) => ListEquationSet e t = 
    ListEquationSet [e t] | ListBot
	deriving Eq

instance (TermEquation e t) => Show (ListEquationSet e t) where
	showsPrec _ ListBot r = showString "<bot>" r
	showsPrec _ (ListEquationSet eqs) r = shows eqs r

instance (TermEquation e t) => EquationSet ListEquationSet e t where
    emptySet = ListEquationSet []
    cSet eqs = ListEquationSet eqs
    cBotSet  = ListBot

    addToSet (ListEquationSet eqs) eq =  ListEquationSet (eq:eqs)
    addToSet ListBot _ = ListBot

    toEquationList (ListEquationSet eqs) = eqs
    toEquationList ListBot = []
           
    isEmpty (ListEquationSet eqs) = null eqs
    isEmpty ListBot = False

    isEqBot ListBot = True
    isEqBot _ = False


