-- |This is the module containing a very simple implementation
-- of Terms.

module Gersdorf.ContextMatching.Base.SimpleTerm (
    toSimpleTerm,
    SimpleTerm,
    SimpleTermNode,
    module Gersdorf.ContextMatching.Base.Term
) where

import Gersdorf.Data.ExtendedTree
import Gersdorf.ContextMatching.Base.Term 
import Debug.Trace

type SimpleTerm = ExtendedTree TermType
type SimpleTermNode = TermNode SimpleTerm

instance TermTypeable SimpleTerm where
    -- Get Name of the root of this term
    getName t = getName (getType t)
    getType = getContent

instance Term SimpleTerm 

instance TermIterator SimpleTerm 

instance Show SimpleTerm where
    showsPrec _ t r = showTerm t r

instance TermBuilder SimpleTerm where
    -- Implementation of factory members
    cFunction n tss = cNode (TermFunction n) tss
    cFunctionT n tss = cFunction n (map extractNode tss)
    cVar n = cNode (TermVariable n) [] 
    cContextVar n t = cNode (TermContextVariable n) [t]
    cContextVarT n t = cContextVar n (extractNode t)
    cHole = cNode TermHole []

    cTerm = cTree

    replaceTerm ct ntn = replaceSubtree ct ntn

toSimpleTerm :: (ConvertableContainerTree t ExtendedTree TermType, Term (t TermType)) =>
    t TermType
    -> SimpleTerm
toSimpleTerm = cTree . convertTree 

{--instance (ConvertableContainerTree t1 t2 tt, TermTypeable tt) => ConvertableTerm (t1 TermType) (ExtendedTree TermType) where
    convertTerm t1 = toSimpleTerm t1 --cTree $ (convertTree t1) 
--}

instance ConvertableTerm SimpleTerm ExtendedTree TermType where
    convertTerm t1 = t1
