-- |This module imports all currently used Terms and configures
-- them correctly (i. e. defines type synonyms for currently used implementation
-- types etc.).
module Gersdorf.ContextMatching.Base.Terms (
    module Gersdorf.ContextMatching.Base.UnificationProblem,
    ExtendedTerm,
    ContextTerm,
    ContextTermNode,
    ContextTermEq,
    ContextUP
) where

import Gersdorf.ContextMatching.Base.Term 
import Gersdorf.ContextMatching.Base.ExtendedTerm
import Gersdorf.ContextMatching.Base.TermEquation
import Gersdorf.ContextMatching.Base.SimpleTermEquation
import Gersdorf.ContextMatching.Base.UnificationProblem
import Gersdorf.ContextMatching.Base.SimpleUnificationProblem

-- |Type synonym for currently used Termtype
type ContextTerm = ExtendedTerm
type ContextTermNode = ExtendedTermNode
type ContextTermEq = SimpleTermEquation ContextTerm
type ContextUP = ListEquationSet SimpleTermEquation ExtendedTerm
