module Gersdorf.ContextMatching.General.CorrespondingPositions.CorrespondingPosFunctions (
    corrPosFunctionsProvider,
    correspondingPosFunctions
) where

import Data.Maybe
import Debug.Trace

import Gersdorf.Data.List
import Gersdorf.Data.Tuple

import Gersdorf.ContextMatching.Base.TermEquation
import Gersdorf.ContextMatching.Base.PositionTerm
import Gersdorf.ContextMatching.General.Rules.Split

corrPosFunctionsProvider :: (PositionTerm t tp) =>
  CorrPosProvider t tp
corrPosFunctionsProvider =
  cCorrPosProvider "correspondingPosFunctions" 
                   correspondingPosFunctions 
                   False
 
correspondingPosFunctions :: (PositionTerm t tp) => 
    (t,t) -> [(tp, tp)]
correspondingPosFunctions (l,r) =
    let uniqueFunctions t = 
          uniquesBy (\a b -> compare (getType a) 
                                     (getType b))
          $ filter isFunction 
          $ toList t
        functionsR = uniqueFunctions r
        functionsL = uniqueFunctions l
        
        uniqueTermPairs = 
          zipEqualsBy (\a b -> compare (getType a)
                                       (getType b))
                      functionsL
                      functionsR
    in  map (scalarApply getPath) uniqueTermPairs


