module Gersdorf.ContextMatching.General.Rules.BotRemove (
    botRemoveRule
) where

import Gersdorf.ContextMatching.General.Rule
import Gersdorf.Data.BacktrackingChoice
import Debug.Trace

botRemoveRule :: (EnvPosEqSet es eq t tp) => Rule es eq t tp
botRemoveRule = Rule { ruleName = "botRemove", ruleF = botRemove }

botRemove :: (EnvPosEqSet es eq t tp) => RuleFunction es eq t tp
botRemove = RuleFunction botRemove'
    where
    botRemove' :: (EnvPosEqSet es eq t tp) => es eq t -> [BacktrackingChoice (es eq t)]
    botRemove' eset  
        | isApplicable                = [cBacktrackingDet eset]
                                                           
        | otherwise                   = [cBacktrackingNo]     -- rule not applicable
        
        where
        isApplicable :: Bool
        isApplicable = isEqBot eset


