module Gersdorf.ContextMatching.General.Rules.Decompose (
    decomposeRule
) where

import Gersdorf.ContextMatching.General.Rule
import Debug.Trace

decomposeRule :: (EnvPosEqSet es eq t tp) => Rule es eq t tp
decomposeRule = cSimpleRule1 "decompose/collision" decompose

decompose :: (EnvPosEqSet es eq t tp) => es eq t -> eq t -> RuleResult eq t
decompose _ eq
        | isApplicable                                -- decompose
          && isFunction r
          && (arity l == arity r)
          && (getType l == getType r) = cRuleResult (childrenExtract l r)
                                                    []
                                                           
        | isApplicable                = RRBot         -- collision
        | otherwise                   = RRNothing     -- rule not applicable
        
        where
        (l, r) = getPair eq
        isApplicable :: Bool
        isApplicable = isFunction l


