module Gersdorf.ContextMatching.General.Rules.HoleDecompose (
    holeDecomposeRule
) where

import Gersdorf.ContextMatching.General.Rule

holeDecomposeRule :: (EnvPosEqSet es eq t tp) => Rule es eq t tp
holeDecomposeRule = cSimpleRule1 "holeDecompose" holeDecompose

holeDecompose :: (EnvEquationSet es eq t) => es eq t -> eq t -> RuleResult eq t
holeDecompose _ eq 
        | isApplicable
          && isHole r  = cRuleResult [] []  -- hole decompose
                                                          
        | isApplicable = RRBot              -- hole collision
        | otherwise    = RRNothing
    
        where
        (l, r) = getPair eq
        isApplicable :: Bool
        isApplicable = isHole l
