module Gersdorf.ContextMatching.General.Rules.SolvedDummy (
   solvedDummyRule
) where

import Gersdorf.ContextMatching.General.Rule
import Debug.Trace

solvedDummyRule :: (EnvPosEqSet es eq t tp) => Rule es eq t tp
solvedDummyRule = cSimpleRule1 "solvedDummy" solvedDummy

solvedDummy :: (EnvPosEqSet es eq t tp) => es eq t -> eq t -> RuleResult eq t
solvedDummy eset eq
        | isApplicable &&
          hasSubstitution eset (getType l) = 
                                        let boundInstance = case (lookupSubstitution eset (getType l)) of
                                                               Nothing -> error "Could not find Substitution. Should not happen."
                                                               (Just t) -> t
                                        in  if (boundInstance == r)
                                               then cRuleResult [] []
                                               else RRBot

        | isApplicable &&
          isContextVariable l &&
          (getHoleCount r /= 1)       = RRBot
          
        | isApplicable                = cRuleResult [] [(getType l, r)]
                                                           
        | otherwise                   = RRNothing     -- rule not applicable
        
        where
        (l, r) = getPair eq
        isApplicable :: Bool
        isApplicable = isSolvedVariable l
