module Gersdorf.ContextMatching.General.Rules.VariableSplit (
   variableSplitRule
) where

import Debug.Trace

import Gersdorf.ContextMatching.General.Rule
import Gersdorf.ContextMatching.Base.PositionTerm
import Gersdorf.Data.BacktrackingChoice

-- | Regel wie folgt:
-- { X[s] =? t } -> { X[_] =? C[_] && s =? t'}
--                  (falls s != _ && t = C[t'])
--
variableSplitRule :: (EnvPosEqSet es eq t tp) => Rule es eq t tp
variableSplitRule = cSimpleRule "VariableSplit" variableSplit

variableSplit :: (EnvPosEqSet es eq t tp) => 
        es eq t 
        -> eq t 
        -> [BacktrackingChoice (RuleResult eq t)]
variableSplit eset eq
        | isApplicable
          && (not $ isHole eq_s)
          
          = let eq_X_just = cTerm $ cContextVar (getName eq_X) cHole
                eq_s_extr = cTree $ extractNode eq_s
                result    =
                    cBacktrackingMany $
                        map (\(eq_C,eq_t') -> 
                                 cRuleResult [cEquation eq_X_just eq_C,
                                              cEquation eq_s_extr eq_t']
                                             [])
                            (permuteContextTerms eq_t) 
                {-result    =
                    cBacktrackingMany $
                         [ cRuleResult [cEquation eq_X_just eq_C, cEquation eq_s_extr eq_t'] []
                           | (eq_C, eq_t') <- permuteContextTerms eq_t ]
                -}
            in  [result]
          
        | otherwise                    = [cBacktrackingNo]
    
        where
        -- initialization of rule variables
        eq_X = getLeft eq
        eq_s = head $ getChildren eq_X
        eq_t = getRight eq

        isApplicable :: Bool
        isApplicable = isContextVariable eq_X



