module Gersdorf.ContextMatching.General.SimpleHeuristic (
    sequenceHeuristic,
    module Gersdorf.ContextMatching.General.Heuristic
) where

import Gersdorf.ContextMatching.General.Heuristic
import Gersdorf.Data.Trie 
import Data.Maybe

sequenceHeuristic :: [Rule] -> HeuristicFunction
sequenceHeuristic rules = \applRules -> sequenceHeuristic' rules (toFMapRules applRules)
    where
    sequenceHeuristic' :: [Rule] -> StringTrie Rule -> Rule
    sequenceHeuristic' [] _ = error "No rule found."
    sequenceHeuristic' (r:rs) m = maybe (sequenceHeuristic' rs m) id (lookupFM (name r) m) 

    toFMapRules :: [Rule] -> StringTrie Rule
    toFMapRules rules = listToFM $ zip (map name rules) rules
