-- | Das Modul beinhaltet Testterme, Gleichungen etc.
module Gersdorf.ContextMatching.Test.TestData (
    linearExponential,
    module Gersdorf.ContextMatching.Test.TestFunctions
) where

import Gersdorf.ContextMatching.Base.Terms
import Gersdorf.ContextMatching.Test.TestFunctions


linearExponential :: Int -> ContextUP
linearExponential n = cProblem [cEquation (cTerm $ left n) (cTerm $ right n)]
    where left :: Int -> ContextTermNode
          left i 
            | i >= 1    = cContextVar ("X" ++ show i) 
                            (cContextVar ("Y" ++ show i)
                              (cFunction "h" [left (i-1)]))
            | otherwise = cFunction "a" []

          right :: Int -> ContextTermNode
          right i 
            | i >= 1    = cFunction "g" 
                            [cFunction "h" [right (i-1)]]
            | otherwise = cFunction "a" []
 
