module Gersdorf.ContextMatching.Test.TestFunctions (
    solveLinear,
    solveLinearApply,
    solveLinearTest,
    solveLinearDecision,
    getErrorsLinearTest
) where

import Gersdorf.ContextMatching.Base.HeapTerm
import Gersdorf.ContextMatching.Linear.LinearCM
import Gersdorf.ContextMatching.Base.Terms
import Gersdorf.ContextMatching.Base.TermParser
import Gersdorf.ContextMatching.Base.Substitution

parseString :: String -> ContextUP
parseString s = read s

solveLinearDecision :: String -> Bool
solveLinearDecision s = solveLinearCMDecision (parseString s)

solveLinear ::  String -> [Substitution HeapTerm]
solveLinear s = solveLinearCM (parseString s)

solveLinearApply :: String -> [(Substitution HeapTerm, [ExtendedTerm])]
solveLinearApply s = map (\(subst, sol) -> (subst, map fst sol)) (solveLinearTest s)

solveLinearTest :: String -> [(Substitution HeapTerm, [(ExtendedTerm, Bool)])]
solveLinearTest s = map (\subst -> (subst, map (applyAndCheck subst . getLeft) termequations))
                        (solveLinearCM cup)
    where cup = parseString s
          termequations = toEquationList cup
          applyAndCheck :: Substitution HeapTerm -> ContextTerm -> (ExtendedTerm, Bool)
          applyAndCheck subst t = (appliedResult, appliedResult == t)
            where appliedResult = snd $ applySubstitution t subst
          
getErrorsLinearTest :: String -> [(Substitution HeapTerm, [(ExtendedTerm, Bool)])]
{-getErrorsLinearTest s = filter ((>) 0 . length . snd)
                          $ map (filter (not . snd) . snd)
                          $ solveLinearTest s
-}                          
getErrorsLinearTest s = filter ((>) 0 . length . snd)
                          $  map (\p -> (fst p, filter (not . snd) $ snd p))
                          $  solveLinearTest s                        
