module Gersdorf.ContextMatching.Test.TestGeneralProblems (
    regressionTest1,
    
    decomposeP,
    collisionP,
    holeDecomposeP,
    
    contextEliminateP,
    contextEliminatePFail,

    multiContextCollisionP,
    variableSplitP,

    bottomDecomposeP,
    bottomDecomposePFail,
    bottomDecomposePFail2,

    paperSampleP,
    paperSampleP2,
    corrPosP,

    splitLinearLoopingP,
    wrongVariableSplitP,
    difficultP1,

    linearExponential,
    module Gersdorf.ContextMatching.Base.TermParser,
    module Gersdorf.ContextMatching.Base.TermGenerator
) where

import Gersdorf.ContextMatching.Base.TermGenerator
import Gersdorf.ContextMatching.Base.TermParser
import Gersdorf.ContextMatching.Test.TestData

-----------------------------------------------------------------------------
-- TestProbleme 
-----------------------------------------------------------------------------
regressionTest1 :: [ContextUP]
regressionTest1 = [decomposeP, collisionP, holeDecomposeP, 
                   contextEliminateP, contextEliminatePFail,
                   multiContextCollisionP, variableSplitP,
                   bottomDecomposeP, bottomDecomposePFail,
                   bottomDecomposePFail2, paperSampleP, paperSampleP2, corrPosP,
                   splitLinearLoopingP, differenceP, wrongVariableSplitP]

decomposeP :: ContextUP
decomposeP = read "[ f(x) =? f(a(b())) ]"

collisionP :: ContextUP
collisionP = read "[ f(x) =? g(a(b())) ]"

holeDecomposeP :: ContextUP
holeDecomposeP = read "[ _ =? _ ]"

contextEliminateP :: ContextUP
contextEliminateP = read "[ X[f(a())] =? g(f(a())) , X[_] =? g(_)]"
-- fail w/ Kontext bereits anders gelst.
contextEliminatePFail :: ContextUP
contextEliminatePFail = read "[ X[_] =? f(_), X[f(a())] =? g(f(a()))]"

multiContextCollisionP :: ContextUP
multiContextCollisionP = read "[ f(_, a(_)) =? f(b(), a(_)) ]"

variableSplitP :: ContextUP
variableSplitP = read "[ C[f(x)] =? g(f(a()), h(f(b()))) ]"

bottomDecomposeP :: ContextUP
bottomDecomposeP = read "[ h(_, f(_, x), _) =? h(_, f(_, b()), _) ]"
-- fail w/ Lcher in unterschiedlichen Argumenten
bottomDecomposePFail :: ContextUP
bottomDecomposePFail = read "[ h(_, f(x, _), _) =? h(_, f(_, b()), _) ]"
-- fail w/ unterschiedlichem Funktionssymbol
bottomDecomposePFail2 :: ContextUP
bottomDecomposePFail2 = read "[ h(_, g(_, x), _) =? h(_, f(_, b()), _) ]"

paperSampleP :: ContextUP
paperSampleP = read "[ X[f(Y[a()], Y[g(_)])] =? f(g(a()), f(a(), g(_))) ]"

paperSampleP2 :: ContextUP
paperSampleP2 = read "[ X[f(Y[a()], Y[g(c())])] =? f(g(b()), f(a(), g(c()))) ]"

corrPosP :: ContextUP
corrPosP = read "[ C[f(g(_), h(y))] =? r(f(g(_), h(b()))) ]"

splitLinearLoopingP :: ContextUP
splitLinearLoopingP = read "[ X[f(Y[b()])] =? g(f(h(b()))) ]"

differenceP :: ContextUP
differenceP = read "[f3(X1[X2[f3(f4(f3(f3(f2(_,f3(f0()),f0()))),f2(f3(f3(f0())),f3(v0),f1(f0()))))]]) =? f3(f2(f3(f4(f3(f3(f3(f0()))),f3(f4(f3(f4(f3(f3(f2(_,f3(f0()),f0()))),f2(f3(f3(f0())),f3(f1(f1(f3(f4(f3(f4(f0(),f0())),f3(f3(f0()))))))),f1(f0())))),f3(f0()))))),f1(f3(f0())),f3(f3(f0()))))]"

{-
Bei diesem Problem wurde ein falsches solved-Dummy durchgefhrt! <f0()/X2> ist verboten!

Current: <[] :: { (X1,f2(f3(_),f3(_))), (X2,f0()) }>
Steps:
[Identity] <[X1[X2[_]] =? f2(f3(_),f3(f0()))] :: {  }>
[VariableSplit] <[X1[_] =? f2(f3(_),f3(_)),X2[_] =? f0()] :: {  }>
[solvedDummy] <[X2[_] =? f0()] :: { (X1,f2(f3(_),f3(_))) }>
[solvedDummy] <[] :: { (X1,f2(f3(_),f3(_))), (X2,f0()) }>
-}
wrongVariableSplitP :: ContextUP
wrongVariableSplitP = read "[X1[X2[_]] =? f2(f3(_), f3(f0()))]"

-- Problem mit > 60000 Steps in baseStrategy
difficultP1 :: ContextUP
difficultP1 = read "[X1[X2[X0[f4(X3[X2[f2(f4(f2(f4(f4(f2(f2(f3(f4(v0),f2(f2(f4(v0)))))))))))]])]]] =? f1(f4(f4(f3(f2(f4(f4(f3(f3(f3(f2(f2(f4(f2(f4(f4(f2(f2(f3(f4(f1(f2(f2(f0())))),f2(f2(f4(f1(f2(f2(f0()))))))))))))))),f0()),f4(f0())),f4(f4(f0())))))),f0()))))]"
