module Gersdorf.ContextMatching.Test.TestTermGeneratorParameters (
    defaultRTP,
    varRTP, cvarRTP,
    holeRTP,
    smallRTP, smallCRTP,
    arityRTP
) where

import Gersdorf.ContextMatching.Base.TermGenerator
import Gersdorf.Algorithms.Random

defaultRTP :: TermGeneratorParameter
defaultRTP = TermGeneratorParameter {
    termSize = 50,
    variableSize = 20,
    varParameter = TermTypeParameter { termTypeCount = 2, termTypeWeight = 20 },
    maxOccurenceVar = 5,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 20 },
    maxOccurenceCVar = 2,
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 10 },
    maxArity = 3,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}

arityRTP :: TermGeneratorParameter
arityRTP = TermGeneratorParameter {
    termSize = 50,
    variableSize = 20,
    varParameter = TermTypeParameter { termTypeCount = 4, termTypeWeight = 30 },
    maxOccurenceVar = 5,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 20 },
    maxOccurenceCVar = 2,
    funcParameter = TermTypeParameter { termTypeCount = 4, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 10 },
    maxArity = 10,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}

varRTP :: TermGeneratorParameter
varRTP = TermGeneratorParameter {
    termSize = 50,
    variableSize = 20,
    varParameter = TermTypeParameter { termTypeCount = 4, termTypeWeight = 70 },
    maxOccurenceVar = 10,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 20 },
    maxOccurenceCVar = 2,
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 10 },
    maxArity = 3,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}

cvarRTP :: TermGeneratorParameter
cvarRTP = TermGeneratorParameter {
    termSize = 50,
    variableSize = 20,
    varParameter = TermTypeParameter { termTypeCount = 2, termTypeWeight = 20 },
    maxOccurenceVar = 2,
    cvarParameter = TermTypeParameter { termTypeCount = 4, termTypeWeight = 70 },
    maxOccurenceCVar = 4, 
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 20 },
    maxArity = 3,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}


holeRTP :: TermGeneratorParameter
holeRTP = TermGeneratorParameter {
    termSize = 50,
    variableSize = 20,
    varParameter = TermTypeParameter { termTypeCount = 2, termTypeWeight = 20 },
    maxOccurenceVar = 5,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 50 },
    maxOccurenceCVar = 2,
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 30 },
    maxArity = 3,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}

smallRTP :: TermGeneratorParameter
smallRTP = TermGeneratorParameter {
    termSize = 15,
    variableSize = 8,
    varParameter = TermTypeParameter { termTypeCount = 2, termTypeWeight = 20 },
    maxOccurenceVar = 3,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 20 },
    maxOccurenceCVar = 2,
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 10 },
    maxArity = 2,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}

smallCRTP :: TermGeneratorParameter
smallCRTP = TermGeneratorParameter {
    termSize = 15,
    variableSize = 8,
    varParameter = TermTypeParameter { termTypeCount = 2, termTypeWeight = 20 },
    maxOccurenceVar = 3,
    cvarParameter = TermTypeParameter { termTypeCount = 3, termTypeWeight = 40 },
    maxOccurenceCVar = 4,
    funcParameter = TermTypeParameter { termTypeCount = 5, termTypeWeight = 50 },
    holeParameter = TermTypeParameter { termTypeCount = 1, termTypeWeight = 10 },
    maxArity = 2,
    randomRangeF = randomRIO,
    distributionF = distributeIO
}


