-- | Das Modul enthlt Typklassen zu Datentypen, die Adressierbar sind, d. h.
-- die eine Adresse besitzen bzw. die mit einer Adresse adressierbar sind.
module Gersdorf.Data.Adressable (
    Adressable(..),
    AdressTarget(..)
) where

-- | Ein algebraischer Datentyp, der eine Adresse besitzt.
class Adressable a where
    getAdress :: a -> Int

-- | Ein algebraischer Datentyp, auf dem eine Adresse anwendbar ist.
class AdressTarget a where
    -- |Liefert ein Datum, das eine bestimmte Adresse besitzt
    getAt :: a   -- ^ Ziel, auf dem die Adresse definiert ist
        -> Int   -- ^ Adresse
        -> a     -- ^ Ergebnis

