module Gersdorf.Data.Container (
    Container(..),
    AdressableContainer(..),
    module Gersdorf.Data.Adressable
) where

import Gersdorf.Data.Adressable

-- | Ein Container ber einem Elementtyp c. Ein Container beinhaltet ein Element.
-- Ein Container kann strukturiert sein (ein Baum); in diesem Fall kann der Container
-- auf andere Container verweisen und so eine grere Struktur bilden.
class Container c e where
   -- | Liefert das Element, das der Container beinhaltet.
   getContent :: c e -> e 

-- | Ein AdressableContainer ist ein Container, dessen Elemente adressierbar sind.
-- Daher ist der Container ein AdressTarget (so dass man ber einen Container zu
-- anderen Containern gelangt).
class (AdressTarget (c e), Container c e) => AdressableContainer c e where
    -- | Liefert aus dem Container ein Element an einer bestimmten Adresse
    getElementAt :: c e  -- ^ der AdressableContainer 
        -> Int           -- ^ Adresse
        -> e             -- ^ das Element an der gegebenen Adresse
    getElementAt c = getContent . getAt c
