module Gersdorf.Data.Flatable (
    Flatable(..)
) where

-- | Ein strukturierter Datentyp ist flatable, falls seine Elemente in eine Liste
-- berfhrbar sind.
class Flatable f e where
    -- | berfhrt einen strukturierten Datentyp in eine Liste seiner Elemente.
    flatten :: f e -- ^ Strukturierter Datentyp f ber Elemente e
        -> [e]     -- ^ Liste der Elemente

-- | Eine Liste ist trivialerweise Flatable.
instance Flatable ([]) e where
    flatten = id
