module Gersdorf.Data.Stack (
    Stack(..)
) where

class Stack st a where
    emptyStack :: st a
    isStackEmpty :: st a -> Bool
    push :: a -> st a -> st a
    pop :: st a -> st a
    top :: st a -> a

    -- | Falls es ein oberstes Element des Stacks gibt, wird
    --   die Funktion darauf angewandt und der Stack dementsprechend
    --   gendert.
    topUpdate :: (a -> a) -> st a -> st a
    topUpdate f st
        | isStackEmpty st = st
        | otherwise =
            let el         = top st
                restStack  = pop st
            in  push (f el) restStack
