module Gersdorf.Data.StandardTreePath (
    StandardTreePath
) where

import Gersdorf.Data.Hashable
import Gersdorf.Data.Tree


data StandardTreePath = StandardTreePath {
    stpPath :: [Int],
    stpHash :: Int32
} deriving Show

instance Eq StandardTreePath where
    a == b = (stpHash a == stpHash b) && (stpPath a == stpPath b)

instance TreePath StandardTreePath where
    toPathIndexList p = stpPath p
   
    topIndex p 
         | null list = error "no top index"
         | otherwise = head list
         where
         list = stpPath p
    
    popPath p
         | null list = error "no top index"
         | otherwise = mkPath (tail list) 
         where
         list = stpPath p

    isEmptyPath p = null (stpPath p)

instance TreePathBuilder StandardTreePath where
    mkPath is = StandardTreePath { stpPath = is, stpHash = hash is }


