module Gersdorf.Data.TreeFiniteMap (
    TreeFiniteMap,
    module Gersdorf.Data.FiniteMap
) where

import Gersdorf.Data.FiniteMap
import qualified Data.FiniteMap as DFM
import Gersdorf.ContextMatching.Base.Utilities

type TreeFiniteMap = DFM.FiniteMap

instance (Ord k) => FiniteMap DFM.FiniteMap k where
    emptyFM = DFM.emptyFM

    lookupFM k fm = {-# SCC "lookup TreeFiniteMap" #-}
                    DFM.lookupFM fm k

    bindFM k a fm = {-# SCC "bind TreeFiniteMap" #-}
                    DFM.addToFM fm k a         

    listToFM l = DFM.listToFM l
    fmToList fm = DFM.fmToList fm

instance (Show k, Show e) => Show (DFM.FiniteMap k e) where
	showsPrec _ fm r = showPredList "{ " (DFM.fmToList fm) ", " " }" r
