module Gersdorf.Monad.IOUtil (
    printIO, printIOString, printIOFile,
    sequenceG
) where

import System.IO

-- outputs any showable IO-action.
printIO :: (Show a) => IO a -> IO ()
printIO act = do a <- act
                 print a

printIOString :: IO String -> IO ()
printIOString act = do str <- act
                       putStr str

printIOFile ::
    String         -- ^ FileName
    -> IO String
    -> IO ()
printIOFile path act =
    do str <- act
       h <- openFile path WriteMode
       hPutStr h str
       hClose h


sequenceG :: [IO a] -> IO [a]
sequenceG [] = return []
sequenceG (a:as) =
    do r <- a
       rs <- sequenceG as
       return (r:rs)
    


