module Test.Center.Command (
    testCommand,
    processCommand
) where

import Test.Center.CommandParser

newtype CommandDescriptions a = CommandDescriptions [(String, CommandFunction a)]
type CommandFunction a = [Parameter a] -> a

processCommand :: (Show a) => Command a -> CommandDescriptions a -> Either String a
processCommand (Command cmdName ps) (CommandDescriptions cds) = 
    case (lookup cmdName cds) of
        Nothing -> Left ("Could not find command " ++ cmdName)
        Just f -> Right $ f (map processParam ps)
    where
    processParam (PCommand c) =
      case (processCommand c (CommandDescriptions cds)) of
          l@(Left _) -> PLiteral "error"
          Right r -> PResult r
    processParam s = s

testCommand :: CommandFunction String
testCommand ps = "Huhu! " ++ (show ps)

testCommand2 :: CommandFunction Integer
testCommand2 ps = 3

