module Test.Center.IOHelpers (
    output,
    outputLn,
    prompt,
    promptQuestion
) where

import System.Console.Readline
import System.IO

--
-- IO library
--

output :: String -> IO ()
output s = do putStr s
              hFlush stdout

outputLn :: String -> IO ()
outputLn s = do putStrLn s
                hFlush stdout

prompt :: IO (Maybe String)
prompt = do r <- readline "> "
            case r of
                Just s | length s > 0 -> do addHistory s
                                            return r
                       | otherwise -> return r
                Nothing -> return Nothing

promptQuestion :: String -> IO (Maybe String)
promptQuestion quest = do outputLn quest
                          prompt


