--module Main where
module Test.LinearProfile where
import Gersdorf.ContextMatching.Test.TestData
import Gersdorf.ContextMatching.Linear.LinearCM
import Gersdorf.ContextMatching.Linear.LinearityTest
import Gersdorf.ContextMatching.Base.HeapTerm 
import Gersdorf.ContextMatching.Base.Terms
import Gersdorf.ContextMatching.Base.Substitution
import qualified System.Environment

getSize :: [String] -> Int
getSize args = read (args !! 0)

getLength :: [String] -> Int
getLength args = read (args !! 1)

displayResult :: [String] -> Bool
displayResult args = if (length args == 3) then (args !! 2) == "yes"
                                           else False

{- getResult :: (Show a) => ContextUP -> [String] -> (b, [a])
getResult prob args = if (length args == 3) then getResult' (args !! 2)
                                       else (result, repeat ".")
    where getResult' arg | arg == "yes" = (result, result)
                         | arg == "apply" = 
          result = solveLinearCM prob
-}

process :: Int   -- ^ size
	-> Int   -- ^ resultlength
	-> Bool  -- ^ display results?
	-> IO ()
process s rl dr = let problem = linearExponential s
                      term    = getLeft (head $ toEquationList problem)
                      result  =  solveLinearCM problem 
       		      resultApplied = map (\subst -> snd $ applySubstitution term subst) result

		  in  do print ("Problem: " ++ show problem)
			 tick rl dr result
			 

main :: IO ()
main = do args <- System.Environment.getArgs
          let resultlength = getLength args
          let size = getSize args
          let display = displayResult args

          print ("Computing linear exponential test with size=" ++ show size ++ 
            ", length=" ++ show resultlength ++ ", displayResult=" ++ show display ++ "\n")

	  process size resultlength display
          
tick :: (Show a) => Int -> Bool -> [a] -> IO ()
tick n d [] = return ()
tick n d (s:ss) | n > 0 = do if (d) then print ((show n) ++ "." ++ (show s) )
                                         else print ((show n) ++ ".")
                             tick (n-1) d ss
                | otherwise = return ()                                    
