module Main where

import Gersdorf.ContextMatching.Base.SemiSolvedSubstitution
import Gersdorf.ContextMatching.Base.HeapTerm
import Gersdorf.ContextMatching.Base.Terms

getTerm :: String -> ContextTerm
getTerm s = cVar s

ht :: String -> HeapTerm
ht s = toHeapTerm $ getTerm s

getSubstitution :: SemiSolvedSubstitution HeapTerm HeapPosition
getSubstitution = substAnd [substOr [substBot, substVar (ht "a") (ht "a"), substTop],
                            substTop, substOr [substVar (ht "b") (ht "b"),
                                               substVar (ht "c") (ht "c")]
                           ]

getSubstitution2 :: SemiSolvedSubstitution HeapTerm HeapPosition
getSubstitution2 = substOr [substVar (ht "a") (ht "a"), 
                            substAnd [substVar (ht "b") (ht "b"),
                                      substOr [substBot, substBot, substBot]]
                            ]

getSubstitution3 :: SemiSolvedSubstitution HeapTerm HeapPosition
getSubstitution3 = substOr [substBot,
                            substAnd [substVar (ht "b") (ht "b"),
                                      substTop]
                            ]

main :: IO()
main = do let subst = getSubstitution3
          let before = subst
          print ("Before: " ++ show before)
          let after = simplify subst
          print ("After: " ++ show after)
          let generated = generate after
          print ("Generated: " ++ show generated)
              

