--module Main where
module Test.SolveLinear where

import Gersdorf.ContextMatching.Test.TestData
import Gersdorf.ContextMatching.Linear.LinearCM
import Gersdorf.ContextMatching.Base.HeapTerm
import Gersdorf.ContextMatching.Base.Terms
import Gersdorf.ContextMatching.Base.Substitution
import qualified System.Environment

getProblem :: [String] -> ContextUP
getProblem args = read (args !! 0)

getLength :: [String] -> Int
getLength args = if (length args >= 2) then read (args !! 1)
                                       else 9999999999

displayResult :: [String] -> Bool
displayResult args = if (length args >= 3) then (args !! 2) == "no"
                                           else True

process :: ContextUP
	-> Int  -- ^ result length
        -> Bool -- ^ display results
	-> IO ()
process p rl dr = let term = getLeft (head (toEquationList p))
                      result = solveLinearCM p
                      resultApplied = map (\subst -> snd $ applySubstitution term subst) result
                  in  tick rl dr result

processS :: String
	-> Int
	-> Bool
	-> IO ()
processS ps rl dr = process (read ps :: ContextUP) rl dr

main :: IO ()
main = do args <- System.Environment.getArgs
          let resultlength = getLength args
          let problem = getProblem args
          print ("Computing linear solution for " ++ show problem ++ " with count=" ++ show resultlength)

	  process problem resultlength (displayResult args)         
 
tick :: (Show a) => Int -> Bool -> [a] -> IO ()
tick n d ss = tick' 1 d ss
  where tick' i d [] = return ()
        tick' i d (s:ss) | i <= n = do if (d) then print ((show i) ++ "." ++ (show s) )
                                              else print ((show i) ++ ".")
                                       tick' (i+1) d ss
                         | otherwise = return ()                                    
