module Test.TestCenter where

import System.Console.GetOpt
import qualified System.Environment

import Test.Command
import Test.TestStatistic
import Test.TestSolve

programName :: String
programName = "Test.TestCenter"
      
globalUsage :: String
globalUsage =
    "Usage is: " ++ programName ++ " [command] [commandoptions]\n\n"
    ++ "available commands: statistic - computes statistics\n"
    ++ "                    solve     - solves problem\n\n"
    ++ "To get a list of available options, use " ++ programName ++ " --help.\n"
    ++ "\n"
   
commands :: [CommandListEntry]
commands = [ CommandListEntry statisticCommand,
             CommandListEntry solveCommand ]
           
          
main :: IO ()
main = 
    do args <- System.Environment.getArgs
       if (length args == 0)
        then putStr globalUsage
        else executeCommandEntry commands (head args) (tail args) globalUsage
