#/bin/bash
#
# Simple calling script for hmake.
#

function usage() {
    echo "Usage: $0 -c|-p|--clean|-i <programmname> [compileroptions]"
    exit 1
}

FUNCTION=$1
PROFILEOPTIONS=""
COMPILER="ghc"

PROGRAMMNAME=$2
if [ -z "$PROGRAMMNAME" ]; then
    echo "Programmname fehlt."
    usage
fi
COMPILEROPTIONS="--make -odir bin -main-is $PROGRAMMNAME.main"

case "$FUNCTION" in
    -c)
     ;;
    --clean)
      hmake -clean $HMAKEOPTIONS $PROGRAMMNAME
      exit 0
      ;;
    -p)
      PROFILEOPTIONS='-prof -auto-all'
      ;;
    -i)
      COMPILER='ghci6'
      COMPILEROPTIONS=""
      ;;
    *)
      usage
esac

shift 2
COMPILEROPTIONS="${COMPILEROPTIONS} -fglasgow-exts -package parsec"
#echo "Starting: $COMPILER $PROFILEOPTIONS $COMPILEROPTIONS $@ $PROGRAMMNAME"
#$COMPILER $HMAKEOPTIONS $PROFILEOPTIONS $COMPILEROPTIONS $@ $PROGRAMMNAME
echo "Starting: $COMPILER $HMAKEOPTIONS $PROFILEOPTIONS $COMPILEROPTIONS $@ $PROGRAMMNAME"
$COMPILER $HMAKEOPTIONS $PROFILEOPTIONS $COMPILEROPTIONS $@ $PROGRAMMNAME

if [ $? -eq 0 -a -e a.out -a "$FUNCTION" != "-i" ]; then
  mv a.out bin/$PROGRAMMNAME
fi
